# Created by pyp2rpm-3.2.1
%global pypi_name     pykafka
%global alphatag_dot  dev.1
%global alphatag      .dev1

# Note: there's already a python-kafka package which is a separate
# project (kafka-python on pypi)

Name:           python-%{pypi_name}
Version:        2.8.1
Release:        0.3%{?alphatag}%{?dist}
Summary:        Full-Featured Pure-Python Kafka Client

License:        ASL 2.0
URL:            https://github.com/Parsely/%{pypi_name}
Source0:        %{url}/archive/%{version}-%{alphatag_dot}/%{pypi_name}-%{version}-%{alphatag_dot}.tar.gz
# Removes frozen version restrictions on BuildRequires
# https://github.com/Parsely/pykafka/pull/1020
Patch0:         pykafka-0001-remove-version-restrictions.patch

BuildRequires:  gcc
BuildRequires:  librdkafka-devel

%description
PyKafka is a cluster-aware Kafka client for Python.
PyKafka’s primary goal is to provide a similar level of abstraction to the
JVM Kafka client using idioms familiar to Python programmers and exposing the
most Pythonic API possible.

%package -n     python3-%{pypi_name}
Summary:        Full-Featured Pure-Python Kafka Client
%py_provides python3-%{pypi_name}

BuildRequires:  python3-devel
BuildRequires:  python3-snappy
BuildRequires:  %{py3_dist gevent}
BuildRequires:  %{py3_dist kazoo}
BuildRequires:  %{py3_dist lz4}
BuildRequires:  %{py3_dist mock}
BuildRequires:  %{py3_dist pytest}
BuildRequires:  %{py3_dist pytest-cov}
BuildRequires:  %{py3_dist setuptools}
BuildRequires:  %{py3_dist tabulate}
BuildRequires:  %{py3_dist traceback2}
BuildRequires:  %{py3_dist unittest2}
# Currently not in repos
# BuildRequires:  %%{py3_dist lz4tools}
# BuildRequires:  %%{py3_dist parametrized}
# BuildRequires:  %%{py3_dist xxhash}

Requires:       %{py3_dist gevent}
Requires:       %{py3_dist kazoo}
Requires:       %{py3_dist setuptools}
Requires:       %{py3_dist six}
Requires:       %{py3_dist tabulate}

%description -n python3-%{pypi_name}
%{description}


%prep
%autosetup -n %{pypi_name}-%{version}-%{alphatag_dot}


%build
%py3_build


%install
%py3_install
cp -p %{buildroot}/%{_bindir}/kafka-tools %{buildroot}/%{_bindir}/kafka-tools-3
ln -sf %{_bindir}/kafka-tools-3 %{buildroot}/%{_bindir}/kafka-tools-%{python3_version}
# Remove tests as they're not installed in package specific path
rm -rf %{buildroot}%{python3_sitearch}/tests
# Remove python module C source code
rm %{buildroot}%{python3_sitearch}/%{pypi_name}/rdkafka/_rd_kafkamodule.c


%check
# FIXME: Some BuildRequires are not in the repos yet
# make tests non-failing until it is available
%{__python3} setup.py test ||:


%files -n python3-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/kafka-tools
%{_bindir}/kafka-tools-3
%{_bindir}/kafka-tools-%{python3_version}
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/%{pypi_name}-*.egg-info


%changelog
* Tue Dec 8 2020 Andy Mender <andymenderunix@fedoraproject.org> - 2.8.1-0.3.dev1
- Add patch for test dependency version resolution

* Tue Dec 8 2020 Andy Mender <andymenderunix@fedoraproject.org> - 2.8.1-0.2.dev1
- Remove Python 2 backwards compat (package not in EPEL anymore)
- Remove Python package version restrictions (no longer needed)
- Include LICENSE file in package

* Tue Dec 8 2020 Andy Mender <andymenderunix@fedoraproject.org> - 2.8.1-0.1.dev1
- Update to 2.8.1-dev.1
- Use GitHub tarballs for Source0 (more up-to-date)
- Add missing BuildRequires (previously pulled in via PIP)

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-0.13.dev2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 2.6.0-0.12.dev2
- Rebuilt for Python 3.9

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-0.11.dev2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Oct 03 2019 Miro Hrončok <mhroncok@redhat.com> - 2.6.0-0.10.dev2
- Rebuilt for Python 3.8.0rc1 (#1748018)

* Thu Oct 03 2019 Javier Peña <jpena@redhat.com> - 2.6.0-0.9.dev2
- Removed unittest2 dependency from python3 subpackage, not needed

* Mon Aug 19 2019 Miro Hrončok <mhroncok@redhat.com> - 2.6.0-0.8.dev2
- Rebuilt for Python 3.8

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-0.7.dev2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Apr 30 2019 Javier Peña <jpena@redhat.com> - 2.6.0-0.6.dev2
- Disable the python2 subpackage on Fedora (bz#1701959)

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-0.5.dev2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-0.4.dev2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 2.6.0-0.3.dev2
- Rebuilt for Python 3.7

* Tue May 29 2018 Miro Hrončok <mhroncok@redhat.com> - 2.6.0-0.2.dev2
- Fix python ambiguous requires

* Tue Feb 14 2017 hguemar <karlthered@gmail.com> - 2.6.0.dev2-1
- Initial package.
